      SUBROUTINE SPLF(X, N, Y, C, NC, V, M, F, IER)
************************************************************************
*  INTERPOLATION BY THE CUBIC SPLINE.                                  *
*  PARAMETERS                                                          *
*    (1) X: 1-DIM. ARRAY FOR KNOWN POINTS                              *
*    (2) N: NUMBER OF KNOWN POINTS                                     *
*    (3) Y: 1-DIM. ARRAY FOR FUNCTION'S VALUES ON KNOWN POINTS         *
*    (4) C: 2-DIM. WORKING ARRAY                                       *
*    (5) NC: ROW SIZE OF THE ARRAY (C)                                 *
*    (6) V: 1-DIM. ARRAY FOR POINTS WHICH INTERPOLATION MUST BE MADE   *
*    (7) M: NUMBER OF POINTS FOR WHICH INTERPOLATION MUST BE MADE      *
*    (8) F: 1-DIM. WORKING ARRAY                                       *
*    (9) IER: ERROR CODE                                               *
*  COPYRIGHT   T. OGUNI   JUNE 30 1989   VERSION 1.0                   *
************************************************************************
       IMPLICIT REAL*8(A-H,O-Z)
       DIMENSION X(N), Y(N), C(NC,3), V(M), F(M)
C
      IF (N .LT. 2 .OR. M .LT. 1 .OR. NC .LT. N-1) THEN
       IER = 2
       WRITE(*,*) '(SUBR. SPLF) INVALID ARGUMENT. ', N, NC, M
       RETURN
      ENDIF
      IER = 0
      I = 1
      DO 90 K=1,M
       V1 = V(K) - X(I)
       IF (V1) 10, 30, 40
   10  IF (I .GT. 1) GO TO 20
       IER = 1
       GO TO 80
   20  I = I - 1
       V1 = V(K) - X(I)
       IF (V1) 10, 30, 80
   30  F(K) = Y(I)
       GO TO 90
   40  IF (I .LT. N) GO TO 50
       IER = 1
       I = N - 1
       GO TO 80
   50  V2 = V(K) - X(I+1)
       IF (V2) 80, 60, 70
   60  I = I + 1
       GO TO 30
   70  I = I + 1
       V1 = V2
       GO TO 40
   80  F(K) = Y(I) + V1 * (C(I,1) + V1 * (C(I,2) + V1 * C(I,3)))
   90 CONTINUE
C
      RETURN
      END

