program read_pil4
! This program works to calculcate kappa_max for each HFER. 20180710
use pgplot
use ifport
implicit none
character*100 :: cvar
! === precision type ===
!integer, parameter :: DP = kind(1.0d0)
!integer, parameter :: SP = kind(1.0)
!integer, parameter :: DPC = kind((1.0d0,1.0d0))
real(DP), parameter :: PI=3.14159265358979323846D0
real(DP), parameter :: PI4=PI*4
real(DP), parameter :: PI8=PI*8
real(DP), parameter :: vec_plot_max=200.0d0
real(DP), parameter :: Mm2cm=1.0D8
! === parameters ===
!integer,parameter :: MX=256, MY=128 ! original grid
integer,parameter :: MX=512, MY=256 ! original grid
integer,parameter :: NX=512, NY=256 ! grid for plotting
integer,parameter :: N_graph = 8 ! number of graphs
integer,parameter :: LNS = 1000 ! array size for PIL
integer,parameter :: PNTS = 1000 ! array size for grid points of PIL
integer,parameter :: MXY=MX*MY
integer,parameter :: N_REC=10
integer,parameter :: N_TIME=100
integer,parameter :: IOLOG=6
!integer,parameter :: IOLOG=40
!integer,parameter :: IOLOG2=41
integer,parameter :: IOLABEL=61
integer,parameter :: IOPIL=62
integer,parameter :: IOOVER=63
integer,parameter :: IOPLOT=50
integer,parameter :: IO_PARA=51
integer,parameter :: IO_bottom1=101
integer,parameter :: IO_bottom2=102
integer,parameter :: IO_OUT_HFER=201
integer,parameter :: IO_DATA_HFER=301
integer,parameter :: IO_OUT_PIL=202
integer,parameter :: IO_OUT_KAPPAR=209
integer,parameter :: IO_DATA_KAPPAR=210
integer,parameter :: LABELMAX=1000
! === same scale for X and Y ===
logical :: same_scale=.TRUE.
logical :: log_scale(2)=(/.FALSE.,.FALSE./)
! === file name ===
character (len=8) :: file_log='log_hfe_'
character (len=9) :: file_log2='data_hfe_'
character (len=10) :: file_label='DATA_label'
character (len=8)  :: file_pil  ='DATA_pil'
character (len=9)  :: file_over ='DATA_over'
! === variables ===
character pwd*80
character cnoaa*5,cyear*4,cmonth*2,cday*2,cenergy*4
character clp*3
character cgraph(0:N_graph)*16
character c2*2
data cgraph /'label','Tw','Tw.abs(Bz)','abs(B-BP)','abs(r0-r1)','Bz','X1','mag_shear','abs(Bt)'/
!
integer :: i,j,k,l,m,n,n1(1),i_abs,i_arrow,ipalett
integer :: ig, ix, jy, ino, icol0, ilw0, igraph, igraph0, inoaa, istate
integer :: iyear, imonth, iday, i_time, pixel_number_x, pixel_number_y
integer :: grid_number_x, grid_number_y, grid_number_z
integer :: number_of_label
integer :: number_of_label_with_pil
integer,dimension(0:MX,0:MY) :: label
integer,dimension(0:MX,0:MY,LABELMAX) :: frag=1
integer,dimension(LABELMAX) :: iarea
integer,dimension(LNS,PNTS,3) :: pil
integer,dimension(LABELMAX,PNTS,3) :: label_pil
integer :: pil_number
integer :: nover ! The total number of overlying field
integer,dimension(LNS) :: pil_points,pil_label
integer,dimension(LABELMAX) :: label_pil_points
integer,dimension(MXY,4) :: overlying
integer :: line_width, line_width0, icolar
!
real(DP) :: xflare,yflare
real(DP) :: x_length_Mm, y_length_Mm
real(DP) :: grid_length_x_Mm, grid_length_y_Mm
real(DP) :: pixel_length_x_Mm, pixel_length_y_Mm
real(DP) :: B_unit_gauss
real(DP) :: graph_min(0:N_graph),graph_max(0:N_graph)
         !1:x0,2:y0,3:z0,4:x1,5:y1,6:z1,7:bx,8:by,9:bz,10:int_alpha_dl
real(DP) :: bottom0(0:MX,0:MY,10) 
real(DP) :: bottom(0:MX,0:MY,10) 
real(DP) :: feng(0:MX,0:MY) 
!
real(DP) :: bplot(0:MX,0:MY,2) 
real(DP) :: cplot(0:NX,0:NY,2),vplot(0:NX,0:NY,2)
real(DP) :: vplot_p(0:NX,0:NY,2),vplot_n(0:NX,0:NY,2)
real(DP) :: x_1(0:MX),x_2(0:NX),y_1(0:MY),y_2(0:NY),x_c,y_c
real(DP) :: x_2_min,x_2_max,y_2_min,y_2_max
real(DP) :: zoom_fact
integer ::  zoom_var
real(DP) :: x,y,absab
real(DP) :: pil_x0,pil_y0
real(DP) :: pil_x1,pil_y1
real(DP) :: dx, dy, dxdy_cgs
real(DP) :: dx_1, dy_1, dx_2, dy_2
real(SP) :: x0, y0 ! the world coordinate of left-bottom
real(SP) :: x0_krl, y0_krl ! the world coordinate of left-bottom
real(SP) :: x1_krl, y1_krl ! the world coordinate of left-bottom
real(SP) :: x0_kre, y0_kre ! the world coordinate of left-bottom
real(SP) :: x1_kre, y1_kre ! the world coordinate of left-bottom
real(SP) :: delx, dely ! pixel size
real(SP) :: delx_krl, dely_krl ! pixel size
real(SP) :: delx_kre, dely_kre ! pixel size
real(SP) :: width, aspect, width_for_100Mm
real(SP) :: width_krl=12.0, aspect_krl=0.75
real(SP) :: width_kre=12.0, aspect_kre=0.75
real(SP) :: x_single(PNTS),y_single(PNTS),x_r4,y_r4
real(DP) :: arrow_fact, fenergy_label, abs_del_b
real(DP) :: hfer_area  (LABELMAX), & ! Area (cm^2)
            hfer_eng2d (LABELMAX), & ! 2d_energy (erg/cm)
            hfer_eng3d (LABELMAX), & ! energy (erg)
            hfer_bfluxp(LABELMAX), & ! mag flux in positive pole (Mx)
            hfer_bfluxn(LABELMAX), & ! mag flux in negative pole (Mx)
            hfer_bflux (LABELMAX), & ! total mag flux (fluxp+fluxn)
            hfer_ftwist(LABELMAX), & ! twist flux, Int Tw.Bz dS (Mx)
            hfer_atwist(LABELMAX)    ! averaged twist, ftwist/bflux
real(DP) :: pil_length (LNS), &
            pil_overfluxp(LNS), &
            pil_overfluxn(LNS), &
            pil_overflux (LNS), &
            pil_overtwist(LNS), &
            pil_kappamax (LNS), &
            pil_kappa_rmax(LNS,N_REC)
real(DP) :: pill_rc (LNS,PNTS), &
            pill_twp(LNS,PNTS), &
            pill_ovf(LNS,PNTS), &
            pill_ova(LNS,PNTS), &
            pill_ove(LNS,PNTS)
real(DP) :: energy_xflare=1.0D32, &
            energy_mflare=1.0D31, &
            rc_critical=1.0D0
real(DP) :: hfer_pil_length   (LABELMAX), &
            hfer_overfluxp(LABELMAX), &
            hfer_overfluxn(LABELMAX), &
            hfer_overflux (LABELMAX), &
            hfer_overtwist(LABELMAX), &
            hfer_kappamax (LABELMAX), &
            hfer_kappa_rmax(LABELMAX,N_REC)
real(DP) :: overlyingflux
real(DP) :: rcmin(LNS),xrcmin(LNS),yrcmin(LNS)
real(DP) :: kappa_c=0.1D0,tf_c(PNTS)
real(DP) :: twistflux, kappa_r(0:N_REC)
real(DP) :: rn_rec(N_REC),dr_rec=PI/6
real(DP) :: rcmin_x(N_TIME,3),emax_rc(N_TIME,3), &
            e_hfer_max(N_TIME),e_hfer_tot(N_TIME)
!
integer ::  loc_kappa_rmax(LNS,N_REC,1:3)
integer ::  n1_rc(LNS,1)
width_for_100Mm=3.0
arrow_fact=5.0d-3
! === read plot window ===
     open(IOPLOT,file='./PLOT_WINDOW',status='OLD',action='READ',ERR=9888)
go to 9988
9888 open(IOPLOT,file='../PLOT_WINDOW0',status='OLD',action='READ')
9988 read(IOPLOT,*) x_2_min,x_2_max,y_2_min,y_2_max, &
  zoom_fact, zoom_var, i_abs, i_arrow, width, fenergy_label
! If zoom_fact=0 then x_2_min,x_2_max,y_2_min,y_2_max c$would work.
! IF i_arrow=1 then vectors are plotted.
! IF width = 0.0, then width is automatically set. 
! IF fenergy_label > 0, then the high-free-energy regions are labeled.
!
! === read parameter ===
  open(IO_PARA,file='Parameters.txt',status='OLD',action='READ')
  read(IO_PARA,*) inoaa, iyear, imonth, iday, i_time, &
                 pixel_number_x, pixel_number_y, &
                 pixel_length_x_Mm, pixel_length_y_Mm, &
                 grid_number_x, grid_number_y, grid_number_z, &
                 x_length_Mm, y_length_Mm, &
                 grid_length_x_Mm, grid_length_y_Mm, &
                 B_unit_gauss
  close(IO_PARA)
  write(cnoaa,'(I5.5)') inoaa
  write(cyear,'(I4.4)') iyear
  write(cmonth,'(I2.2)') imonth
  write(cday,'(I2.2)') iday
  write(cenergy,'(I4.4)') int(fenergy_label)
! === open files ===
! open(IOLOG,file=file_log//cenergy,form='FORMATTED',status='OLD')
! open(IOLOG2,file=file_log2//cenergy,form='FORMATTED',status='OLD')
 open(IOLABEL,file=file_label,form='UNFORMATTED',status='OLD',action='READ')
 open(IOPIL,file=file_pil,form='UNFORMATTED',status='OLD',action='READ')
 open(IOOVER,file=file_over,form='UNFORMATTED',status='OLD',action='READ')
! === write log ===
  write(IOLOG,*) '===== Plot Parameters ====='
  write(IOLOG,*) 'x_2_min ',x_2_min
  write(IOLOG,*) 'x_2_max ',x_2_max
  write(IOLOG,*) 'y_2_min ',y_2_min
  write(IOLOG,*) 'y_2_max ',y_2_max
  write(IOLOG,*) 'zoom_fact ',zoom_fact
  write(IOLOG,*) 'zoom_var ',zoom_var
  write(IOLOG,*) 'i_abs ',i_abs
  write(IOLOG,*) 'i_arrow ',i_arrow
  write(IOLOG,*) 'width ',width
!
  do ig = 1, N_graph
   read(IOPLOT,*) graph_min(ig), graph_max(ig)
  end do
 close(IOPLOT)
 if(zoom_fact.NE.0.0) then
   arrow_fact=arrow_fact/zoom_fact
 end if
!
  write(IOLOG,*)
  write(IOLOG,*) '===== Active Region ====='
  write(IOLOG,*) 'NOAA  ',inoaa
  write(IOLOG,*) 'Year  ',iyear
  write(IOLOG,*) 'Month ',imonth
  write(IOLOG,*) 'Day   ',iday
  write(IOLOG,*) 'Time  ',i_time
  write(IOLOG,*) 'deltaX',pixel_length_x_Mm,'(Mm)'
  write(IOLOG,*) 'deltaY',pixel_length_y_Mm,'(Mm)'
  write(IOLOG,*) 'X_len ',x_length_Mm,'(Mm)'
  write(IOLOG,*) 'Y_len ',y_length_Mm,'(Mm)'
  write(IOLOG,*) 'grid_length_x_Mm ',grid_length_x_Mm,'(Mm)'
  write(IOLOG,*) 'grid_length_y_Mm ',grid_length_y_Mm,'(Mm)'
!
! === read NOAA # ===
  istate = getcwd(pwd)
!  write(*,*) 'DEBUG 01',istate, pwd
!
  open(IO_bottom1,file='bottom.001',form='UNFORMATTED',status='OLD',action='READ')
  read(IO_bottom1) bottom0
  close(IO_bottom1)

  open(IO_bottom2,file='bottom.002',form='UNFORMATTED',status='OLD',action='READ')
  read(IO_bottom2) bottom
  close(IO_bottom2)
! === put the physical dimension ===
  bottom0(:,:,1) = bottom0(:,:,1)*x_length_Mm
  bottom0(:,:,2) = bottom0(:,:,2)*x_length_Mm
  bottom0(:,:,3) = bottom0(:,:,3)*x_length_Mm
  bottom0(:,:,4) = bottom0(:,:,4)*x_length_Mm
  bottom0(:,:,5) = bottom0(:,:,5)*x_length_Mm
  bottom0(:,:,6) = bottom0(:,:,6)*x_length_Mm
  bottom0(:,:,7) = bottom0(:,:,7)*B_unit_gauss
  bottom0(:,:,8) = bottom0(:,:,8)*B_unit_gauss
  bottom0(:,:,9) = bottom0(:,:,9)*B_unit_gauss
!
  bottom(:,:,1) = bottom(:,:,1)*x_length_Mm
  bottom(:,:,2) = bottom(:,:,2)*x_length_Mm
  bottom(:,:,3) = bottom(:,:,3)*x_length_Mm
  bottom(:,:,4) = bottom(:,:,4)*x_length_Mm
  bottom(:,:,5) = bottom(:,:,5)*x_length_Mm
  bottom(:,:,6) = bottom(:,:,6)*x_length_Mm
  bottom(:,:,7) = bottom(:,:,7)*B_unit_gauss
  bottom(:,:,8) = bottom(:,:,8)*B_unit_gauss
  bottom(:,:,9) = bottom(:,:,9)*B_unit_gauss
!
x_1(:) = bottom(:,0,1)
y_1(:) = bottom(0,:,2)

! write(*,*) 'DEBUG 02'
!do ix = 0, MX
!write(*,*) ' x1',ix,x_1(ix)
!end do
!
!do jy = 0, MY
!write(*,*) ' y1',jy,y_1(jy)
!end do

if(zoom_fact.eq.0.0) then
 if(x_2_min.eq.0.0 .and. x_2_max.eq.0.0) then
  x_2_min = x_1(0)
  x_2_max = x_1(MX)
 else 
  x_2_min = x_2_min*x_length_Mm
  x_2_max = x_2_max*x_length_Mm
 end if

 if(y_2_min.eq.0.0 .and. y_2_max.eq.0.0) then
  y_2_min = y_1(0)
  y_2_max = y_1(MY)
 else 
  y_2_min = y_2_min*x_length_Mm
  y_2_max = y_2_max*x_length_Mm
 end if
else if(zoom_fact.gt.0.0) then
 i_abs=1
 call find_center(bottom(:,:,zoom_var),i_abs,x_1,y_1,MX,MY,x_c,y_c)
! if i_abs = 1, abs(bottom(:,:,zoom_fact)) is used as the parameter to find the center.
 x_2_min = max(x_1(0) ,x_c - (x_1(MX)-x_1(0))/2/zoom_fact)
 x_2_max = min(x_1(MX),x_c + (x_1(MX)-x_1(0))/2/zoom_fact)
 y_2_min = max(y_1(0) ,y_c - (y_1(MY)-y_1(0))/2/zoom_fact)
 y_2_max = min(y_1(MY),y_c + (y_1(MY)-y_1(0))/2/zoom_fact)
else
 write(IOLOG,*) 'WARNING: zoom_fact ',zoom_fact
 stop
end if
!
dx_1 = x_1(1)-x_1(0)
dy_1 = y_1(1)-y_1(0)
dxdy_cgs = dx_1*dy_1*Mm2cm**2
!
dx_2 = (x_2_max-x_2_min)/NX
dy_2 = (y_2_max-y_2_min)/NY
!
do ix = 0, NX
 x_2(ix) = x_2_min + dx_2*ix
end do
!
do jy = 0, NY
 y_2(jy) = y_2_min + dy_2*jy
end do
!
x0   = x_2_min
y0   = y_2_min
delx = dx_2
dely = dy_2
!
if(width.EQ.0.0) then
  width = (x_2_max-x_2_min)/100.0d0*width_for_100Mm*zoom_fact
end if
aspect = (y_2_max-y_2_min)/(x_2_max-x_2_min)*1.2

! write(*,*) 'DEBUG 03'
!====== contor ======
bplot(:,:,2) = bottom(:,:,9)      ! Bz
!
if(MX.EQ.NX.AND.MY.EQ.NY.AND.zoom_fact.EQ.0.0) then
   cplot(:,:,2)=bplot(:,:,2)
 else
   call spline_2d_periodic(bplot(:,:,2),cplot(:,:,2),x_1,y_1,x_2,y_2,MX+1,MY+1,NX+1,NY+1)
write(*,*) 'spline Bz' !DEBUG
end if
!
!====== vector ======
! Bx & By
call spline_2d_periodic(bottom(:,:,7),vplot(:,:,1),x_1,y_1,x_2,y_2,MX+1,MY+1,NX+1,NY+1)
call spline_2d_periodic(bottom(:,:,8),vplot(:,:,2),x_1,y_1,x_2,y_2,MX+1,MY+1,NX+1,NY+1)
!
do i = 0, NX
do j = 0, NY
   if(sqrt(vplot(i,j,1)**2+vplot(i,j,2)**2).le.vec_plot_max) then
      vplot(i,j,1) = 0.0
      vplot(i,j,2) = 0.0
   end if
end do
end do
!
do i = 0, NX
do j = 0, NY
   if(cplot(i,j,2).ge.0.0) then
      vplot_p(i,j,1) = vplot(i,j,1)
      vplot_p(i,j,2) = vplot(i,j,2)
      vplot_n(i,j,1) = 0.0
      vplot_n(i,j,2) = 0.0
     else 
      vplot_p(i,j,1) = 0.0
      vplot_p(i,j,2) = 0.0
      vplot_n(i,j,1) = vplot(i,j,1)
      vplot_n(i,j,2) = vplot(i,j,2)
   end if
end do
end do
!
if(fenergy_label.gt.0.0) then
  igraph0=0
 else 
  igraph0=1
end if
!
do igraph = igraph0, N_graph
!
!--------High-Free-Energy Region & PIL---------
if (igraph.eq.0) then 
!
  read(IOLABEL) number_of_label,fenergy_label
  if(number_of_label.GT.0) then
    read(IOLABEL) iarea(1:number_of_label)
    read(IOLABEL) label
   else
    iarea(:)=0
  end if
!
  bplot(:,:,1)=label(:,:)
!
  graph_min(0)=0.0
  graph_max(0)=number_of_label
!
! ==== PIL detector ====
!
!  pil_points(:)=0
!  call find_pil(bottom(:,:,9),label,MX,MY,pil,LNS,PNTS, &
!                pil_number,pil_label,pil_points)
!
  read(IOPIL) pil_number,fenergy_label
! write(*,*) 'DEBUG 04',pil_number
!  
  if(pil_number.GT.0) then
    read(IOPIL) pil_points(1:pil_number)
    read(IOPIL) pil_label (1:pil_number)
!
    do l=1,pil_number
    do i=1,pil_points(l)
       read(IOPIL) pil(l,i,:)
    end do
    end do
   else
    pil_points(:)=0
  end if
!
! make the data of pil within each HFER
!
  label_pil_points(:)=0
  do l = 1, pil_number
  do i = 1, pil_points(l)
     label_pil(pil_label(l),label_pil_points(pil_label(l))+i,:) = pil(l,i,:)
  end do
     label_pil_points(pil_label(l))=label_pil_points(pil_label(l)) &
                                   +      pil_points(l)
  end do
!
  number_of_label_with_pil=0
  do l = 1, number_of_label
     if(label_pil_points(l).gt.0) then
        number_of_label_with_pil=number_of_label_with_pil+1
     end if
  end do
!
! ===== search overlying field connectivity for each PIL =====
!
!  call find_overlying(bottom,MX,MY, &
!                      pil,LNS,PNTS,pil_number,pil_label,pil_points, &
!                      overlying,MXY,nover)
!
  read(IOOVER) nover,fenergy_label
  if(nover.GT.0) then
    do i = 1, nover
      read(IOOVER) overlying(i,:)
    end do
  end if
!
!  write(*,*) 'DEBUG 05: the number of over-lying field = ',nover
!  write(IOLOG,*) 'the number of over-lying field = ',nover
!
  if(number_of_label.eq.0) iarea(:)=0
  if(pil_number.eq.0) pil_points(:)=0
!  write(IOLOG2,'(I6,F12.5,7I7)') inoaa,fenergy_label, &
!  number_of_label,sum(iarea),maxval(iarea), &
!       pil_number,sum(pil_points),maxval(pil_points), &
!       nover
!
! ===== calculate the propaties of each High-Free-Energy region ======
!
    feng(:,:) =((bottom(:,:,7)-bottom0(:,:,7))**2 &
               +(bottom(:,:,8)-bottom0(:,:,8))**2)/PI8 ! |B-B_p|
!
  hfer_area  (:)=0.0 ! Area of each high-free-energy region (cm^2)
  hfer_eng2d (:)=0.0 ! Area integrated free energy (erg/cm)
  hfer_eng3d (:)=0.0 ! Estimated free energy (2D_free_energy X SQRT(Area)) (erg)
  hfer_bfluxp(:)=0.0 ! Mag flux of high-free-energy region in positive pole(Mx)
  hfer_bfluxn(:)=0.0 ! Mag flux of high-free-energy region in negative pole(Mx)
  hfer_bflux (:)=0.0 ! total Mag flux of high-free-energy region (Mx)
  hfer_ftwist(:)=0.0 ! \int Tw.|Bz| dS
  hfer_atwist(:)=0.0 ! ttwitt/bflux
!
  do i = 0, MX
  do j = 0, MY
    if(label(i,j).NE.0.AND.label(i,j).LT.LABELMAX) then
     hfer_area  (label(i,j))=hfer_area  (label(i,j))+1.0D0
     hfer_eng2d (label(i,j))=hfer_eng2d (label(i,j))+feng(i,j)
    if(bottom(i,j,9).GT.0.0) then
     hfer_bfluxp (label(i,j))=hfer_bfluxp(label(i,j))+bottom(i,j,9)
    else 
     hfer_bfluxn (label(i,j))=hfer_bfluxn(label(i,j))+abs(bottom(i,j,9))
    end if
     hfer_ftwist(label(i,j))=hfer_ftwist(label(i,j)) &
                            +abs(bottom(i,j,9))*bottom(i,j,10)/PI4 
    end if
  end do
  end do
!
  hfer_area  (:)=hfer_area  (:)*dxdy_cgs
  hfer_eng2d (:)=hfer_eng2d (:)*dxdy_cgs
  hfer_eng3d (:)=hfer_eng2d (:)*SQRT(hfer_area(:))
  hfer_bfluxp(:)=hfer_bfluxp(:)*dxdy_cgs
  hfer_bfluxn(:)=hfer_bfluxn(:)*dxdy_cgs
  hfer_bflux (:)=hfer_bfluxp(:)+hfer_bfluxn(:)
  hfer_ftwist(:)=hfer_ftwist(:)*dxdy_cgs
  hfer_atwist(:)=hfer_ftwist(:)/hfer_bflux(:)
!
!
! ===== calculate the propaties of each PIL ======
!
  pil_length   (:) = 0.0 ! The length of PIL in Mm unit
!
  do l = 1, pil_number
     i = 1
     pil_x0 = x_1(pil(l,i,1))
     pil_y0 = y_1(pil(l,i,2))
     if (pil(l,i,3).EQ.0) then
       pil_x0=pil_x0+0.5D0*dx_1
      else
       pil_y0=pil_y0+0.5D0*dy_1
     end if
  do i = 2, pil_points(l)
     pil_x1 = x_1(pil(l,i,1))
     pil_y1 = y_1(pil(l,i,2))
     if (pil(l,i,3).EQ.0) then
       pil_x1=pil_x1+0.5D0*dx_1
      else
       pil_y1=pil_y1+0.5D0*dy_1
     end if
     pil_length(l)=pil_length(l)+sqrt((pil_x1-pil_x0)**2 &
                                     +(pil_y1-pil_y0)**2)
     pil_x0=pil_x1
     pil_y0=pil_y1
   end do
     hfer_pil_length(pil_label(l))=hfer_pil_length(pil_label(l))+pil_length(l)
   end do
!
!
   do i = 1, nover
    if(bottom(overlying(i,3),overlying(i,4),9).GT.0.0) then
     pil_overfluxp(overlying(i,1))=pil_overfluxp(overlying(i,1))   &
                         + bottom(overlying(i,3),overlying(i,4),9)
     hfer_overfluxp(overlying(i,2))=hfer_overfluxp(overlying(i,2))   &
                         + bottom(overlying(i,3),overlying(i,4),9)   &
                            *frag(overlying(i,3),overlying(i,4),overlying(i,2))
    else
     pil_overfluxn(overlying(i,1))=pil_overfluxn(overlying(i,1))   &
                     + abs(bottom(overlying(i,3),overlying(i,4),9))
     hfer_overfluxn(overlying(i,2))=hfer_overfluxn(overlying(i,2))   &
                     + abs(bottom(overlying(i,3),overlying(i,4),9)) &
                            *frag(overlying(i,3),overlying(i,4),overlying(i,2))
    end if
     pil_overtwist(overlying(i,1))=pil_overtwist(overlying(i,1))   &
                      +abs(bottom(overlying(i,3),overlying(i,4),9)) &
                          *bottom(overlying(i,3),overlying(i,4),10)/PI4
     hfer_overtwist(overlying(i,2))=hfer_overtwist(overlying(i,2))      &
                      +abs(bottom(overlying(i,3),overlying(i,4),9))     &
                          *bottom(overlying(i,3),overlying(i,4),10)/PI4 &
                            *frag(overlying(i,3),overlying(i,4),overlying(i,2))
     frag(overlying(i,3),overlying(i,4),overlying(i,2))=0
   end do
!
          pil_length(:)=     pil_length(:)*Mm2cm
     pil_overfluxp(:)=pil_overfluxp(:)*dxdy_cgs
     pil_overfluxn(:)=pil_overfluxn(:)*dxdy_cgs
     pil_overflux (:)=pil_overfluxp(:)+pil_overfluxn(:)
     pil_overtwist(:)=pil_overtwist(:)*dxdy_cgs
!
     hfer_pil_length(:)=hfer_pil_length(:)*Mm2cm
     hfer_overfluxp (:)=hfer_overfluxp (:)*dxdy_cgs
     hfer_overfluxn (:)=hfer_overfluxn (:)*dxdy_cgs
     hfer_overflux  (:)=hfer_overfluxp (:)+hfer_overfluxn(:)
     hfer_overtwist (:)=hfer_overtwist (:)*dxdy_cgs
!
   do l = 1, pil_number
    if(pil_overflux(l).NE.0.0) then
     pil_kappamax (l)=pil_overtwist(l)/pil_overflux(l)
    end if
   end do
!
   do l = 1, number_of_label
    if(hfer_overflux(l).NE.0.0) then
     hfer_kappamax (l)=hfer_overtwist(l)/hfer_overflux(l)
    end if
   end do
!
! ==== write to OUT_PIL ====
!
  open(IO_OUT_PIL,file='./OUT_PIL',form='FORMATTED')
  do i = 1, pil_number
     write(IO_OUT_PIL,'(I6,2I3,6E12.4)') &
             inoaa,i,pil_label    (i) &
                    ,pil_length   (i) &
                    ,pil_overfluxp(i) &
                    ,pil_overfluxn(i) &
                    ,pil_overflux (i) &
                    ,pil_overtwist(i) &
                    ,pil_kappamax (i)
  end do
  close(IO_OUT_PIL)
!
! ====== search kappa_r_max on a pil and PLOT kappa_r along a pil ======
! ====== This part is new for the version PIL4 =========================
! ====== overlying flux is defined as the flux crossing with a line ====
! ====== between the farest footpoints connecting reconnection area ====
!
do i = 1, N_REC
   rn_rec(i) =-0.2333+dr_rec*i
end do
!
kappa_r(0)=0.0
!
do l = 1, pil_number
do n = 1, pil_points(l)
do m = 1, N_REC
     call cal_twistflux(bottom,MX,MY,pil(l,n,:),rn_rec(m),twistflux)
     call cal_overlying(bottom,MX,MY,pil(l,n,:),rn_rec(m),overlyingflux)
    if(overlyingflux.NE.0.0) then
     kappa_r(m)=twistflux/overlyingflux
    else
     kappa_r(m)=0.0
!!!!debug!!!!
write(*,*) 'kappa_r=0.0 ',l,n,m
!!!!!!!!!!!!!
    end if
end do
!
! ===== find the critical radius of reconnection =====
!
   if((kappa_r(0)-kappa_c)*(kappa_r(N_REC)-kappa_c).gt.0.0) then
       pill_rc(l,n) = rn_rec(N_REC)
!!!!debug!!!!
write(*,*) 'critical radius too large ',l,n,kappa_r(N_REC)
!!!!!!!!!!!!!
    else 
       do m=1, N_REC-1
          if((kappa_r(m)-kappa_c)*(kappa_r(m+1)-kappa_c).LE.0.0) then
            pill_rc(l,n) = (rn_rec(m  )*(kappa_r(m+1)-kappa_c) &
                           +rn_rec(m+1)*(kappa_c     -kappa_r(m)))  &
                          /(kappa_r(m+1)-kappa_r(m))
          end if
        end do
   end if
!
   call cal_twistflux (bottom,MX,MY,pil(l,n,:),pill_rc(l,n),pill_twp(l,n))
   call cal_overlying2(bottom0,bottom,label,MX,MY, &
                       pil(l,n,:),pil_label(l),pill_rc(l,n), &
                       pill_ovf(l,n),pill_ova(l,n),pill_ove(l,n),fenergy_label)
!
!==debug==
!  write(*,*) l,n,pill_rc(l,n),pill_ovf(l,n),pill_ova(l,n),pill_ove(l,n)
!
end do
end do
!
! ===== WRITE Kappa_R data (binary) =====
!
open(IO_DATA_KAPPAR,file='./DATA_Kappa_R',form='UNFORMATTED')
write(IO_DATA_KAPPAR) pil_number,fenergy_label,N_REC
write(IO_DATA_KAPPAR) pil_points(1:pil_number)
write(IO_DATA_KAPPAR) rn_rec(1:N_REC)
do l=1,pil_number
   write(IO_DATA_KAPPAR) pill_rc (l,1:pil_points(l))
   write(IO_DATA_KAPPAR) pill_twp(l,1:pil_points(l))
   write(IO_DATA_KAPPAR) pill_ovf(l,1:pil_points(l))
   write(IO_DATA_KAPPAR) pill_ova(l,1:pil_points(l))
   write(IO_DATA_KAPPAR) pill_ove(l,1:pil_points(l))
end do
close(IO_DATA_KAPPAR)
!
! === PLOT free_energy vs. r_c(0.1) ===
!
!cvar = '?'
cvar = 'AR'//cnoaa//'_rc_free_energy.gif/gif'
x0_kre=29.0
y0_kre=0.0
delx_kre=1.0
dely_kre=0.1
same_scale=.FALSE.
log_scale=(/.TRUE.,.FALSE./)
!
call pgplot__set(width_kre,aspect_kre,x0_kre,y0_kre, &
     delx_kre,dely_kre,6,51, &
     trim(pwd)//'  '//cyear//cmonth//cday//'  '//'NOAA'//cnoaa//' free_energy vs. r_c(0.1)', &
     trim(cvar),same_scale,log_scale)
!
! plot hfer_eng3d
   call PGQCI(icolar)
   call PGSLS(2)
do i = 1, number_of_label
   call PGSCI(i)
   x_single(1)=log10(hfer_eng3d(i))
   x_single(2)=log10(hfer_eng3d(i))
   y_single(1)=0.0
   y_single(2)=6.0
   call PGLINE(2,x_single(1:2),y_single(1:2))
end do
   call PGSCI(icolar)
   call PGSLS(1)
!
do l = 1, pil_number
do m = 1, pil_points(l)
     if(pill_ove(l,m).ne.0.0) then
      x_single(m)=log10(pill_ove(l,m))
     else
      x_single(m)=0.0
     end if
      y_single(m)=pill_rc(l,m)
end do
     call pgsci(pil_label(l))
     ! call pgline(pil_points(l),x_single(1:pil_points(l)),y_single(1:pil_points(l)))
     call pgpt(pil_points(l),x_single(1:pil_points(l)),y_single(1:pil_points(l)),l+1)
     write(c2,'(I2)') l
     call pgtext(x_single(1),y_single(1),c2)
!
     n1_rc(l,:)=minloc(pill_rc(l,1:pil_points(l)))
     rcmin (l)=pill_rc(l,n1_rc(l,1))
     xrcmin(l)=x_1(pil(l,n1_rc(l,1),1))
     yrcmin(l)=y_1(pil(l,n1_rc(l,1),2))
     if(pil(l,n1_rc(l,1),3).EQ.0) then
       xrcmin(l)=xrcmin(l)+0.5D0*dx_1
      else
       yrcmin(l)=yrcmin(l)+0.5D0*dy_1
     end if
!## debug ##
write(*,*) l,rcmin(l),xrcmin(l),yrcmin(l)
!###########
end do
call pgplot__end
!-------------------------------------------------------------------
  write(IOLOG,*)
  write(IOLOG,'(A29,F12.4,A4)') 'the threshold for HFER = ',fenergy_label,' (G)'
  write(IOLOG,'(A29,I5)')    '    the number of HFER = ',number_of_label
 if(number_of_label.GT.0) then
  write(IOLOG,*)
  write(IOLOG,'(A)') ' label pixel  area(cm^2)  eng(erg) r_kappa_c(0.1) bflux(Mx)   twist_flux  ave.twist '
  write(IOLOG,'(A)') '------------------------------------------------------------------------------------'
  do l = 1, number_of_label
   write(IOLOG,'(2I6,6E12.4)') l, iarea(l), hfer_area(l), hfer_eng3d(l), rcmin(l), &
                    hfer_bflux(l), hfer_ftwist(l), hfer_atwist(l)
  end do
 end if
  write(IOLOG,*)
  write(IOLOG,*)
  write(IOLOG,'(A)') ' PIL  HFER#   length(cm)  b.flux(+)   b.flux(-)   total_b.flux o_flux  t.twist/o_flux kappa_r(1Mm) '
  write(IOLOG,'(A)') '---------------------------------------------------------------------------------------------------'
  do l = 1, pil_number
   write(IOLOG,'(2I6,7E12.4)') l, pil_label(l) &
                    ,pil_length(l) &
                    ,pil_overfluxp(l) &
                    ,pil_overfluxn(l) &
                    ,pil_overflux (l) &
                    ,pil_overtwist(l) &
                    ,pil_kappamax (l) &
                    ,pil_kappa_rmax(l,3) 
  end do
!
! ===========================DATA OUT=============================
! write(*,*) 'DEBUG 09'
!
  open(IO_OUT_HFER,file='./OUT_HFER',form='FORMATTED')
  do i = 1, number_of_label
     write(IO_OUT_HFER,'(I6,I3,17E12.4)') &
               inoaa,i,hfer_area  (i) & ! 1,2,3
                      ,hfer_eng3d (i) & ! 4
                      ,rcmin(i) & ! 5
                      ,hfer_eng2d (i) & ! 6
                      ,hfer_bfluxp(i) & ! 7
                      ,hfer_bfluxn(i) & ! 8
                      ,hfer_bflux (i) & ! 9
                      ,hfer_ftwist(i) & ! 10
                      ,hfer_atwist(i) & ! 11
                      ,hfer_pil_length(i) & ! 12
                      ,hfer_overfluxp(i) & ! 13
                      ,hfer_overfluxn(i) & ! 14
                      ,hfer_overflux (i) & ! 15
                      ,hfer_overtwist(i) & ! 16
                      ,hfer_kappamax (i) & ! 17
                      ,grid_length_x_Mm  & ! 18
                      ,grid_length_y_Mm    ! 19

  end do
  close(IO_OUT_HFER)
!
 open(IO_DATA_HFER,file='./DATA_HFER',form='UNFORMATTED')
     write(IO_DATA_HFER) inoaa,number_of_label,grid_length_x_Mm,grid_length_y_Mm
  do i = 1, number_of_label
     write(IO_DATA_HFER) &
                     i,hfer_area  (i) &
                      ,hfer_eng3d (i) &
                      ,rcmin(i) &
                      ,hfer_eng2d (i) &
                      ,hfer_bfluxp(i) &
                      ,hfer_bfluxn(i) &
                      ,hfer_bflux (i) &
                      ,hfer_ftwist(i) &
                      ,hfer_atwist(i) &
                      ,hfer_pil_length(i) &
                      ,hfer_overfluxp(i) &
                      ,hfer_overfluxn(i) &
                      ,hfer_overflux (i) &
                      ,hfer_overtwist(i) &
                      ,hfer_kappamax (i) &
                      ,hfer_kappa_rmax(i,:) 
  end do
 close(IO_DATA_HFER)
!
! write(*,*) 'DEBUG 10'
!--------Magnetic Twist---------
else if (igraph.eq.1) then 
    bplot(:,:,1) = bottom(:,:,10)/PI4 ! magnetic Twist
    bplot(:,MY-1,1) = 0.0
!--------Magnetic Twist Flux Density (Tw.abs(Bz))---------
else if (igraph.eq.2) then
    bplot(:,:,1) = bplot(:,:,1)*abs(bottom(:,:,9)) ! Tw.absBz
!--------Excess from Potential Field ---------
else if (igraph.eq.3) then
    bplot(:,:,1) = sqrt((bottom(:,:,7)-bottom0(:,:,7))**2 &
                       +(bottom(:,:,8)-bottom0(:,:,8))**2) ! |B-B_p|
!--------Footpoint Interval ---------
else if (igraph.eq.4) then 
    bplot(:,:,1) = sqrt((bottom(:,:,4)-bottom(:,:,1))**2 &
                       +(bottom(:,:,5)-bottom(:,:,2))**2) ! |r_0-r_1|
!-------- Bz ---------
else if (igraph.eq.5) then
    bplot(:,:,1) = bottom(:,:,9)      ! Bz
!-------- X_1 ---------
else if (igraph.eq.6) then
    bplot(:,:,1) = bottom(:,:,4)      ! X_1
!-------- Shear Angle ---------
else if (igraph.eq.7) then
    do ix= 0, MX
    do jy= 0, MY
       absab = sqrt(bottom (ix,jy,7)**2+bottom (ix,jy,8)**2) &
              *sqrt(bottom0(ix,jy,7)**2+bottom0(ix,jy,8)**2)
      if(absab.ne.0.0) then
       x = (bottom(ix,jy,7)*bottom0(ix,jy,7)+bottom(ix,jy,8)*bottom0(ix,jy,8)) &
          /absab
       y = (bottom0(ix,jy,7)*bottom(ix,jy,8)-bottom0(ix,jy,8)*bottom(ix,jy,7)) &
          /absab
       bplot(ix,jy,1) = atan2(y,x)/PI*180.0d0
      else
       bplot(ix,jy,1) = 0.0
      end if
    end do
    end do
!-------- Horizontal Field Intensity ---------
else if (igraph.eq.8) then
    bplot(:,:,1) = sqrt(bottom(:,:,7)**2+bottom(:,:,8)**2)
else
    go to 9999
end if
!
if(MX.EQ.NX.AND.MY.EQ.NY.AND.zoom_fact.EQ.0.0) then
  cplot(:,:,1)=bplot(:,:,1)
 else
  call spline_2d_periodic(bplot(:,:,1),cplot(:,:,1),x_1,y_1,x_2,y_2,MX+1,MY+1,NX+1,NY+1)
end if
!
! === plot ===
!
!cvar = '?'
cvar = 'AR'//cnoaa//'_'//trim(cgraph(igraph))//'.gif/gif'
same_scale=.TRUE.
log_scale=(/.FALSE.,.FALSE./)
call pgplot__set(width,aspect,x0,y0,delx,dely,NX,NY, &
     trim(pwd)//'  '//cyear//cmonth//cday//'  '//'NOAA'//cnoaa//'_'//trim(cgraph(igraph)), &
     trim(cvar),same_scale,log_scale)
! call pgmtxt('t',2.0,1.0,1.0,trim(pwd))
!
! === IGRAPH=0 ===
if(igraph.eq.0) then
  ipalett=22
! ------- Color-scale Plot for labeled High-Free-Energy Regions--------
call pgplot__image2(cplot(:,:,1),NX+1,NY+1,graph_min(igraph),graph_max(igraph),ipalett)
! call plot__overlying(bottom,MX,MY,overlying,MXY,nover)
call plot__pil(pil,pil_number,pil_points,pil_label,LNS,PNTS,x_1,MX,y_1,MY)
!
! === IGRAPH>0 ===
 else
! ------- Color-scale Plot --------
  ipalett=2
call pgplot__image2(cplot(:,:,1),NX+1,NY+1,graph_min(igraph),graph_max(igraph),ipalett)
!
! ------- Contour Plot --------
call pgqci(icol0)
call pgqlw(ilw0)
call pgsci(8)
call pgslw(2)
call pgplot__contour(cplot(:,:,2),NX+1,NY+1,-1.0d0,1.0d0,3)
end if
!
! ------- Vector Plot --------
if(i_arrow.eq.1) then
 call pgslw(4)
 call pgsch(0.0)
 call pgsah(2,20.0,0.3)
 call pgsci(1)
 call pgplot__vector (vplot_p(:,:,1),vplot_p(:,:,2),NX+1,NY+1,10,15,arrow_fact)
 call pgsci(0)
! call pgplot__vector (vplot_n(:,:,1),vplot_n(:,:,2),NX+1,NY+1,10,15,arrow_fact)
!
! ------- Connectivity Plot ---------
else if(i_arrow.eq.2) then
  do l = 1, pil_number
   if(rcmin(l).lt.rn_rec(N_REC)) then
    call plot2_overlying(bottom,MX,MY,xrcmin(l),yrcmin(l),rcmin(l))
   end if
  end do
!------ all overlying flux -----
!  call pgsci(0)
!  call plot__connect (bottom(:,:,9),100.d0, &
!      bottom(:,:,1),bottom(:,:,2),bottom(:,:,4),bottom(:,:,5), &
!      MX,MY,5,5)
! ****** plot of kappa_r max point *****
  do l = 1, pil_number
   if(rcmin(l).lt.rn_rec(N_REC)) then
    call pgslw(6)
    call pgsci(1)
    call plot_circle(xrcmin(l),yrcmin(l),rcmin(l))
   end if
  end do
! ----- mark at a point on PIL where flare can likely occur.
else if(i_arrow.eq.3) then
  do l = 1, pil_number
  do m = 1, pil_points(l)
   if(pill_rc(l,m).le.rc_critical) then
    if(pill_ove(l,m).ge.energy_xflare) then
       call pgsci(2)
       line_width = pill_ove(l,m)/energy_xflare
     else if(pill_ove(l,m).ge.energy_mflare*3) then
       call pgsci(1)
       line_width = pill_ove(l,m)/energy_mflare
     else if(pill_ove(l,m).ge.energy_mflare) then
       call pgsci(15)
       line_width = pill_ove(l,m)/energy_mflare
    end if
    if(pill_ove(l,m).ge.energy_mflare) then
       xflare = x_1(pil(l,m,1))
       yflare = y_1(pil(l,m,2))
       if(pil(l,m,3).eq.0) then
          xflare=xflare+0.5D0*dx_1
        else
          yflare=yflare+0.5D0*dy_1
       end if
       call pgqlw(line_width0)
       call pgslw(line_width*2)
       call plot_circle(xflare,yflare,pill_rc(l,m))
       call pgslw(line_width)
    end if
   end if
  end do
  end do
end if
!
call pgplot__end
end do

9999 continue
!close(IOLOG)
!close(IOLOG2)
close(IOLABEL)
close(IOPIL)
close(IOOVER)
end program read_pil4

