subroutine find_center(a,i_abs,x,y,mx,my,xc,yc)
implicit none
integer,intent(in) :: mx, my, i_abs
real(8),intent(in) :: a(0:mx,0:my),x(0:mx),y(0:my)
real(8),intent(out) :: xc, yc
integer :: i, j, a1(1)
real(8),allocatable,dimension(:) :: w0,w1,w2
real(8) :: val_c, ave
!
allocate(w0(0:mx))
allocate(w1(0:mx))
allocate(w2(0:mx))
do i = 0, mx
 w0(i)=sum(abs(a(i,:)))
end do
ave=sum(w0)/(mx+1)
w1(0) = 0.0
do i = 1, mx
 if(w0(i).gt.ave) then
   if(i_abs.NE.1) then
    w1(i)=w1(i-1)+sum(a(i-1,:))
   else
    w1(i)=w1(i-1)+w0(i)
   end if
  else
    w1(i)=w1(i-1)
 end if
end do
val_c = w1(mx)/2
w2(:) = abs(w1(:)-val_c)
a1=minloc(w2)
xc=x(a1(1))
deallocate(w0)
deallocate(w1)
deallocate(w2)
!
allocate(w0(0:my))
allocate(w1(0:my))
allocate(w2(0:my))
do j = 0, my
 w0(j)=sum(abs(a(:,j)))
end do
ave=sum(w0)/(my+1)
w1(0) = 0.0
do j = 1, my
 if(w0(j).gt.ave) then
   if(i_abs.NE.1) then
    w1(j)=w1(j-1)+sum(a(:,j-1))
   else
    w1(j)=w1(j-1)+w0(j)
   end if
  else
    w1(j)=w1(j-1)
 end if
end do
val_c = w1(my)/2
w2(:) = abs(w1(:)-val_c)
a1=minloc(w2)
yc=y(a1(1))
deallocate(w0)
deallocate(w1)
deallocate(w2)
end subroutine find_center
subroutine plot__connect(bz,b_min,x0,y0,x1,y1,MX,MY,Mdelx,Mdely)
implicit none
real(8),intent(in) :: b_min
real(8),intent(in),dimension(0:MX,0:MY) :: bz,x0,y0,x1,y1
real(4) :: x_0,y_0, x_1, y_1
integer,intent(in) :: MX, MY, Mdelx, Mdely
integer :: i,j
!debug
!write(*,*) 'plot__connect ',MX, MY, Mdelx, Mdely
do i = 0, MX, Mdelx
do j = 0, MY, Mdely
 if(abs(bz(i,j)).gt.b_min) then
   x_0 = x0(i,j)
   y_0 = y0(i,j)
   call PGMOVE(x_0,y_0)
   x_1 = x1(i,j)
   y_1 = y1(i,j)
   call PGDRAW(x_1,y_1)
 end if
!debug
! write(*,*) i,j,x_0,y_0,x_1,y_1
end do
end do
end subroutine plot__connect
subroutine plot__overlying(bottom,MX,MY,overlying,MXY,nover)
implicit none
integer,intent(in) :: MX,MY,MXY,nover
real(8),intent(in) :: bottom(0:MX,0:MY,10)
integer,intent(in) :: overlying(MXY,4)
real(4) :: x0,y0,x1,y1
integer :: i,j,n
!
do n=1, nover
   call PGSCI(overlying(n,1))
   i=overlying(n,3)
   j=overlying(n,4)
   x0=bottom(i,j,1)
   y0=bottom(i,j,2)
   x1=bottom(i,j,4)
   y1=bottom(i,j,5)
   call PGMOVE(x0,y0)
   call PGDRAW(x1,y1)
end do
return
end subroutine plot__overlying
subroutine plot2_overlying(bottom,MX,MY,x0,y0,r_rec)
implicit none
integer,intent(in) :: MX,MY
real(8),dimension(0:MX,0:MY,10),intent(in) :: bottom
real(8),intent(in) :: x0,y0,r_rec
real(8) :: x, y, dx, dy, dxdy, r
real(8) :: distance_from_pil, farest_distance(2) 
real(8) :: xp_far, yp_far, xn_far, yn_far ! (x,y) at the farest point connecting to the PIL region
integer :: i, j, ia(1)
integer :: i0, i1, j0, j1 ! index for reconnection region
logical :: cross
!
dx=bottom(1,0,1)-bottom(0,0,1)
dy=bottom(0,1,2)-bottom(0,0,2)
dxdy=dx*dy
ia=minloc(abs(bottom(:,0,1)-x0))
i=ia(1)
ia=minloc(abs(bottom(0,:,2)-y0))
j=ia(1)
!
i0 = max( 0,i-int(r_rec/dx)-1)
i1 = min(MX,i+int(r_rec/dx)+1)
j0 = max( 0,j-int(r_rec/dy)-1)
j1 = min(MY,j+int(r_rec/dy)+1)
!
farest_distance(:)=0.0
do i = i0, i1
    x=bottom(i,0,1)
do j = j0, j1
    y=bottom(0,j,2)
    r=sqrt((x-x0)**2+(y-y0)**2)
 if(r.LT.r_rec) then
     distance_from_pil = sqrt((bottom(i,j,4)-x0)**2 &
                             +(bottom(i,j,5)-y0)**2)
   if(bottom(i,j,9).GT.0.0) then
     if(distance_from_pil.gt.farest_distance(1)) then
        farest_distance(1)=distance_from_pil
        xp_far = bottom(i,j,4)
        yp_far = bottom(i,j,5)
     end if
   else
     if(distance_from_pil.gt.farest_distance(2)) then
        farest_distance(2)=distance_from_pil
        xn_far = bottom(i,j,4)
        yn_far = bottom(i,j,5)
     end if
   end if
 end if
end do
end do
!
if(farest_distance(1).eq.0.0.AND.farest_distance(2).eq.0.0) then
   return
end if
!
   call PGSCI(0)
do i = 0, MX
do j = 0, MY
   call crossing_1(xn_far,yn_far,xp_far,yp_far, &
        bottom(i,j,1),bottom(i,j,2),bottom(i,j,4),bottom(i,j,5),cross)
   if(cross) then
    call PGPT(1,real(bottom(i,j,1)),real(bottom(i,j,2)),1)
   !call PGPT(1,real(bottom(i,j,4)),real(bottom(i,j,5)),1)
   ! call PGMOVE(real(bottom(i,j,1)),real(bottom(i,j,2)))
   ! call PGDRAW(real(bottom(i,j,4)),real(bottom(i,j,5)))
   end if
end do 
end do
!
   call PGSCI(1)
   call PGMOVE(real(x0),real(y0))
   call PGDRAW(real(xn_far),real(yn_far))
   call PGSCI(2)
   call PGMOVE(real(x0),real(y0))
   call PGDRAW(real(xp_far),real(yp_far))
!
return
end subroutine plot2_overlying
subroutine plot__pil(pil,pil_number,pil_points,pil_label,LNS,PNTS,xc,MX,yc,MY)
implicit none
integer,intent(in) :: LNS,PNTS,MX,MY
integer,intent(in) :: pil_number
integer :: l,m
integer,dimension(LNS),intent(in) :: pil_points,pil_label
integer,dimension(LNS,PNTS,3),intent(in) :: pil
real(8) :: xc(0:MX),yc(0:MY)
real(4) :: x, y, angle=0.0, fjust=0.0
character :: text*2
!
do l = 1, pil_number
do m = 1, pil_points(l)
!DEBUG
!write(*,*) l,m,pil(l,m,:)
  if(pil(l,m,3).eq.0) then
    x=(xc(pil(l,m,1))+xc(pil(l,m,1)+1))/2
    y= yc(pil(l,m,2))
  else if(pil(l,m,3).eq.1) then
    x= xc(pil(l,m,1))
    y=(yc(pil(l,m,2))+yc(pil(l,m,2)+1))/2
  else
    write(*,*) 'WARNING (plot__pil) : l,i,pil(l,m,3)',l,m,pil(l,m,3)
  end if
!
  if(m.eq.1) then
    call PGSCI(1)
    if(l.lt.100) then
       if(l.lt.10) then
          write(text,'(I1.1)') l
          ! write(text,'(I1.1)') pil_label(l)
        else
          write(text,'(I2.2)') l
          ! write(text,'(I2.2)') pil_label(l)
       end if
       call PGPTXT(x,y,angle,fjust,trim(text))
!DEBUG
!write(*,*) '(0) ',x,y
    end if
    call PGSCI(0)
    call PGMOVE(x,y)
  else
    call PGDRAW(x,y)
    if(m.eq.pil_points(l)) then
       call PGSCI(2)
       call PGPTXT(x,y,angle,fjust,trim(text))
!DEBUG
!write(*,*) '(1) ',x,y
    end if
  end if
end do
end do
!
end subroutine plot__pil 
subroutine find_overlying(bottom,MX,MY,pil,LNS,PNTS,pil_number,pil_label,pil_points,overlying,MXY,nover)
implicit none
! === precision type ===
integer, parameter :: DP = kind(1.0d0)
integer, parameter :: SP = kind(1.0)
integer, parameter :: DPC = kind((1.0d0,1.0d0))
!
integer,intent(in) :: MX,MY,MXY,LNS,PNTS
integer,intent(in),dimension(LNS,PNTS,3) :: pil
integer,intent(in) :: pil_number
integer,intent(in),dimension(LNS) :: pil_points,pil_label
integer,intent(out),dimension(MXY,4) :: overlying
integer,intent(out) :: nover ! number of overlying field
real(DP),intent(in) :: bottom(0:MX,0:MY,10)
!
integer :: i,j,lpil
logical :: cross
!
nover=0
do lpil = 1, pil_number
 do i = 0, MX
 do j = 0, MY
   call crossing(pil(lpil,:,:),PNTS,pil_points(lpil), &
        bottom(i,j,1),bottom(i,j,2),bottom(i,j,4),bottom(i,j,5),    &
        bottom(0:MX,0,1),MX,bottom(0,0:MY,2),MY,cross)
   if(cross) then
      nover=nover+1
      overlying(nover,1)=lpil
      overlying(nover,2)=pil_label(lpil)
      overlying(nover,3)=i
      overlying(nover,4)=j
      if(nover.eq.MXY) then
         write(*,*) 'WARNING (find_overlying) nover, MXY ',nover,MXY
         return
      end if
!
   end if
 end do
 end do
end do
return
end subroutine find_overlying
subroutine crossing(pil,PNTS,pil_points,x0,y0,x1,y1,xc,MX,yc,MY,cross)
implicit none
integer,intent(in) :: pil_points,MX,MY,PNTS
integer,intent(in),dimension(PNTS,3) :: pil
real(8),intent(in) :: x0,y0,x1,y1,xc(0:MX),yc(0:MY)
real(8) :: a, b, x, y, alpha, beta, xp0, yp0, xp1, yp1
integer :: i
! integer :: idebug
logical,intent(out) :: cross
!
cross=.FALSE.
!
if(x0.EQ.x1.AND.y0.EQ.y1) return
if(xc(maxval(pil(1:pil_points,1))+1).LT.min(x0,x1)) return
if(xc(minval(pil(1:pil_points,1))  ).GT.max(x0,x1)) return
if(yc(maxval(pil(1:pil_points,2))+1).LT.min(y0,y1)) return
if(yc(minval(pil(1:pil_points,2))  ).GT.max(y0,y1)) return
!
a=(y1-y0)/(x1-x0)
b=y0-a*x0
!
do i=1,pil_points-1
!
 if(pil(i,3).NE.pil(i+1,3)) then
  if(pil(i,3).EQ.0) then
     xp0=(xc(pil(i,1))+xc(pil(i,1)+1))/2
     yp0=yc(pil(i,2))
   else
     xp0=xc(pil(i,1))
     yp0=(yc(pil(i,2))+yc(pil(i,2)+1))/2
  end if
  if(pil(i+1,3).EQ.0) then
     xp1=(xc(pil(i+1,1))+xc(pil(i+1,1)+1))/2
     yp1=yc(pil(i+1,2))
   else
     xp1=xc(pil(i+1,1))
     yp1=(yc(pil(i+1,2))+yc(pil(i+1,2)+1))/2
  end if
     alpha = (yp1-yp0)/(xp1-xp0)
     beta  = yp0-alpha*xp0  
     x=(b-beta)/(alpha-a)
     y=alpha*x+beta
!
! idebug=1
!
 else if(pil(i,3).eq.0) then
     xp0=(xc(pil(i,1))+xc(pil(i,1)+1))/2
     xp1=xp0
     yp0=yc(pil(i,2))
     yp1=yc(pil(i+1,2))
     x=xp0
     y=a*x+b
!
! idebug=2
!
 else
     xp0=xc(pil(i,1))
     xp1=xc(pil(i+1,1))
     yp0=(yc(pil(i,2))+yc(pil(i,2)+1))/2
     yp1=yp0
     y=yp0
     x=(y-b)/a
!
! idebug=3
!
 end if
!
    if(((x-x0 )*(x-x1 )+(y-y0 )*(y-y1 ).LE.0.0) &
  .AND.((x-xp0)*(x-xp1)+(y-yp0)*(y-yp1).LE.0.0)) then
   cross = .TRUE.
!DEBUG
! if(min(x0,x1).le.-40.0) then
!   write(*,*) 'crossing ',idebug,x,y
!   write(*,*) 'x0,y0',x0,y0
!   write(*,*) 'x1,y1',x1,y1
!   write(*,*) 'a,b',a,b
!   write(*,*) 'xp0,yp0',xp0,yp0
!   write(*,*) 'xp1,yp1',xp1,yp1
!   write(*,*) 'alpha,beta',alpha,beta
!   write(*,*) 'min&max x ',xc(minval(pil(1:pil_points,1))),&
!                           xc(maxval(pil(1:pil_points,1)))
!   write(*,*) 'min&max y ',yc(minval(pil(1:pil_points,2))),&
!                           yc(maxval(pil(1:pil_points,2)))
!   write(*,*) maxval(pil(1:pil_points,1)),minval(pil(1:pil_points,1)), &
!              maxval(pil(1:pil_points,2)),minval(pil(1:pil_points,2))
! end if
!DEBUG
   return
 end if
!
end do
return
end subroutine crossing
subroutine crossing_1(xp0,yp0,xp1,yp1,x0,y0,x1,y1,cross)
implicit none
real(8),intent(in) :: xp0,yp0,xp1,yp1
real(8),intent(in) :: x0 ,y0 ,x1 ,y1
real(8) :: a, b, x, y, alpha, beta
logical,intent(out) :: cross
!
cross=.FALSE.
!
if(x0.EQ.x1.AND.y0.EQ.y1) then
  !! write(*,*) 'WARNING: crossing_1, x0=x1 AND y0=y1,',x0,y0
  return
end if
if(xp0.EQ.xp1.AND.yp0.EQ.yp1) then
  !! write(*,*) 'WARNING: crossing_1, xp0=xp1 AND yp0=yp1,',xp0,yp0
  return
end if
if(max(xp0,xp1).LT.min(x0,x1)) return
if(min(xp0,xp1).GT.max(x0,x1)) return
if(max(yp0,yp1).LT.min(y0,y1)) return
if(min(yp0,yp1).GT.max(y0,y1)) return
!
a=(y1-y0)/(x1-x0)
b=y0-a*x0
!
 if(xp0.ne.xp1.AND.yp0.ne.yp1) then
     alpha = (yp1-yp0)/(xp1-xp0)
     beta  = yp0-alpha*xp0  
     x=(b-beta)/(alpha-a)
     y=alpha*x+beta
 else if(xp0.eq.xp1) then
     x=xp0
     y=a*x+b
 else
     y=yp0
     x=(y-b)/a
 end if
!
    if(((x-x0 )*(x-x1 )+(y-y0 )*(y-y1 ).LE.0.0) &
  .AND.((x-xp0)*(x-xp1)+(y-yp0)*(y-yp1).LE.0.0)) then
     cross = .TRUE.
  end if
return
end subroutine crossing_1
real*8 function hokan(r,bz,xc,yc,MX,MY)
implicit none
integer,intent(in) :: MX,MY
real(8),intent(in) :: r(2),bz(0:MX,0:MY),xc(0:MX),yc(0:MY)
integer :: i,j
real(8) :: dx, dy, s00,s01,s11,s10,s
!
dx=xc(1)-xc(0)
dy=yc(1)-yc(0)
s = dx*dy
i=r(1)/dx
j=r(2)/dy

s00=(r(1)-xc(i  ))*(r(2)-yc(j  ))/s
s10=(r(1)-xc(i+1))*(r(2)-yc(j  ))/s
s01=(r(1)-xc(i  ))*(r(2)-yc(j+1))/s
s11=(r(1)-xc(i+1))*(r(2)-yc(j+1))/s
!
hokan=s11*bz(i  ,j  ) &
    +s01*bz(i+1,j  ) &
    +s10*bz(i  ,j+1) &
    +s11*bz(i+1,j+1)
!
end function hokan
subroutine lookup_index(indata,NX,NY,i1,j1,l)
implicit none
integer,intent(in) :: NX,NY,i1,j1
integer,intent(out) :: l
integer,dimension(0:NX,0:NY),intent(in) :: indata
integer,dimension(0:1,0:1) :: idata
common /lookup_table/ lookup
integer,dimension(0:15,0:1,0:1) :: lookup
!
idata(0,0)=indata(i1,j1)
idata(1,0)=indata(i1+1,j1)
idata(0,1)=indata(i1,j1+1)
idata(1,1)=indata(i1+1,j1+1)
!
l = 0
do while(l.LE.15)
  if  (idata(0,0).EQ.lookup(l,0,0) &
  .AND.idata(1,0).EQ.lookup(l,1,0) &
  .AND.idata(0,1).EQ.lookup(l,0,1) &
  .AND.idata(1,1).EQ.lookup(l,1,1)) then
    return 
  end if
  l=l+1
end do
!
write(*,*) 'ERR (lookup__index),l>15',indata
return
end subroutine lookup_index
subroutine lookup__set
implicit none
common /lookup_table/ lookup
integer,dimension(0:15,0:1,0:1) :: lookup
!
lookup( 0,:,:) = reshape((/1,1,1,1/),(/2,2/))
lookup( 1,:,:) = reshape((/0,1,1,1/),(/2,2/))
lookup( 2,:,:) = reshape((/1,0,1,1/),(/2,2/))
lookup( 3,:,:) = reshape((/0,0,1,1/),(/2,2/))
lookup( 4,:,:) = reshape((/1,1,1,0/),(/2,2/))
lookup( 5,:,:) = reshape((/0,1,1,0/),(/2,2/))
lookup( 6,:,:) = reshape((/1,0,1,0/),(/2,2/))
lookup( 7,:,:) = reshape((/0,0,1,0/),(/2,2/))
lookup( 8,:,:) = reshape((/1,1,0,1/),(/2,2/))
lookup( 9,:,:) = reshape((/0,1,0,1/),(/2,2/))
lookup(10,:,:) = reshape((/1,0,0,1/),(/2,2/))
lookup(11,:,:) = reshape((/0,0,0,1/),(/2,2/))
lookup(12,:,:) = reshape((/1,1,0,0/),(/2,2/))
lookup(13,:,:) = reshape((/0,1,0,0/),(/2,2/))
lookup(14,:,:) = reshape((/1,0,0,0/),(/2,2/))
lookup(15,:,:) = reshape((/0,0,0,0/),(/2,2/))
return
end subroutine lookup__set 
subroutine find_pil(ddata,label,NX,NY,clines_out,LNS,PNTS, &
                    line_number,line_label_out,line_points_out)
implicit none
integer, parameter :: DP = kind(1.0d0)
integer, parameter :: SP = kind(1.0)
integer, parameter :: DPC = kind((1.0d0,1.0d0))
real(DP), parameter :: PI=3.14159265358979323846D0
real(DP), parameter :: PI4=PI*4
!
real(DP),dimension(0:NX,0:NY),intent(in) :: ddata
integer,dimension(0:NX,0:NY),intent(in) :: label
integer,intent(in) :: NX,NY,LNS,PNTS
integer,intent(out) :: line_number
integer,intent(out) :: line_points_out(LNS)
integer,intent(out) :: line_label_out(LNS)
integer,dimension(LNS,PNTS,3),intent(out) :: clines_out
integer,allocatable,dimension(:) :: line_points,line_label
integer,allocatable,dimension(:,:,:) :: clines
!
integer :: i,j,k,l,ll,lp,ln,nline,i1,j1,k1,lcycle
integer :: i_label,n_same_label,i_line,ii_line(1)
!
integer,allocatable,dimension(:,:) :: linep,linen
integer,allocatable,dimension(:,:) :: idata
logical,allocatable,dimension(:) :: line_mask
logical,allocatable,dimension(:,:) :: checked
!
allocate(linep(PNTS/2,3))
allocate(linen(PNTS/2,3))
allocate(idata(0:NX,0:NY))
allocate(checked(0:NX-1,0:NY-1))
allocate(line_points(LNS),line_label(LNS))
allocate(clines(LNS,PNTS,3))
!
checked(:,:)=.FALSE.
call lookup__set
!
do i = 0, NX
do j = 0, NY
   if(ddata(i,j).GE.0.0) then
     idata(i,j) = 1
    else 
     idata(i,j) = 0
   end if
end do
end do
!
nline=0
do i = 0, NX-1
do j = 0, NY-1
  if(.NOT.checked(i,j)) then
! trace the cotour to the direction of e_z X grad_f
      lp=0
      i1=i
      j1=j
      call lookup_index(idata,NX,NY,i1,j1,l)
      if(l.LE.0.OR.l.GE.15) then
         checked(i1,j1) = .TRUE.
       else
         lcycle=0
      end if
! **** debug ****
! write(*,'(A3,7I4)') 'A: ',i,j,nline,lp,i1,j1,l
! ***************
!
        do while((l.GE.1.AND.l.LE.14) &
            .AND.i1.GE.0.AND.i1.LE.NX-1 &
            .AND.j1.GE.0.AND.j1.LE.NY-1 &
            .AND.lp.LT.PNTS/2 &
            .AND.lcycle.EQ.0)
         if(lp.GT.0.AND.i1.EQ.i.AND.j1.EQ.j) then
            lcycle=1
         end if
! **** debug ****
! write(*,'(A3,7I4)') 'B: ',i,j,nline,lp,i1,j1,l
! ***************
         call lookup_index(idata,NX,NY,i1,j1,l)
         checked(i1,j1) = .TRUE.
! **** debug ****
! write(*,'(A3,7I4)') 'C: ',i,j,nline,lp,i1,j1,l
! ***************
         if(l.EQ.1) then
          lp=lp+1
          i1=i1
          j1=j1
          k1=0
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
          j1=j1-1
         else if(l.EQ.2) then
          lp=lp+1
          i1=i1+1
          j1=j1
          k1=1
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
         else if(l.EQ.3) then
          lp=lp+1
          i1=i1+1
          j1=j1
          k1=1
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
         else if(l.EQ.4) then
          lp=lp+1
          i1=i1
          j1=j1+1
          k1=0
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
         else if(l.EQ.5) then
          lp=lp+1
          if(lp.eq.1.OR.(lp.gt.1.AND.linep(lp-1,1).gt.i1)) then
            k1=0
            linep(lp,1)=i1
            linep(lp,2)=j1
            linep(lp,3)=k1
            j1=j1-1
           else
            j1=j1+1
            k1=0
            linep(lp,1)=i1
            linep(lp,2)=j1
            linep(lp,3)=k1
          end if
         else if(l.EQ.6) then
          lp=lp+1
          i1=i1
          j1=j1+1
          k1=0
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
         else if(l.EQ.7) then
          lp=lp+1
          i1=i1
          j1=j1+1
          k1=0
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
         else if(l.EQ.8) then
          lp=lp+1
          k1=1
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
          i1=i1-1
         else if(l.EQ.9) then
          lp=lp+1
          k1=0
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
          j1=j1-1
         else if(l.EQ.10) then
          lp=lp+1
          if(lp.eq.1.OR.(lp.gt.1.AND.linep(lp-1,2).gt.j1)) then
           i1=i1+1
           k1=1
           linep(lp,1)=i1
           linep(lp,2)=j1
           linep(lp,3)=k1
          else
           k1=1
           linep(lp,1)=i1
           linep(lp,2)=j1
           linep(lp,3)=k1
           i1=i1-1
          end if
         else if(l.EQ.11) then
          lp=lp+1
          i1=i1+1
          k1=1
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
         else if(l.EQ.12) then
          lp=lp+1
          k1=1
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
          i1=i1-1
         else if(l.EQ.13) then
          lp=lp+1
          k1=0
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
          j1=j1-1
         else if(l.EQ.14) then
          lp=lp+1
          k1=1
          linep(lp,1)=i1
          linep(lp,2)=j1
          linep(lp,3)=k1
          i1=i1-1
         else
          write(*,'(A12,5I5)') 'WARNING (+) ',i,j,i1,j1,l
         end if
! **** debug ****
! write(*,'(A3,7I4)') 'D: ',i,j,nline,lp,i1,j1,l
! ***************
         if(lp.EQ.PNTS/2) then
           write(*,*) 'WARNING: lp larger than PNTS/2',PNTS/2
         end if
! **** check the labeling domain *****
         if (((linep(lp,3).EQ.0).AND. &
              (label(linep(lp,1)  ,linep(lp,2)) &
              *label(linep(lp,1)+1,linep(lp,2))).EQ.0) &
         .OR.((linep(lp,3).EQ.1).AND. &
              (label(linep(lp,1),linep(lp,2)) &
              *label(linep(lp,1),linep(lp,2)+1)).EQ.0)) then 
            ! write(*,'(A16,6I5)') 'on the boundary+',i,j,i1,j1,k1,lp
            lp=lp-1
            go to 100
         end if
        end do
! trace the cotour to the direction of -e_z X grad_f
 100  continue
      ln=0
      i1=i
      j1=j
        call lookup_index(idata,NX,NY,i1,j1,l)
        checked(i1,j1)=.TRUE.
        do while((l.GE.1.AND.l.LE.14) &
            .AND.i1.GE.0.AND.i1.LE.NX-1 &
            .AND.j1.GE.0.AND.j1.LE.NY-1 &
            .AND.ln.LT.PNTS/2 &
            .AND.lcycle.EQ.0)
        call lookup_index(idata,NX,NY,i1,j1,l)
! write(*,'(A3,7I4)') 'E: ',i,j,nline,lp,i1,j1,l
        checked(i1,j1)=.TRUE.
         if(l.EQ.1) then
          ln=ln+1
          k1=1
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
          i1=i1-1
         else if(l.EQ.2) then
          ln=ln+1
          k1=0
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
          j1=j1-1
         else if(l.EQ.3) then
          ln=ln+1
          k1=1
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
          i1=i1-1
         else if(l.EQ.4) then
          ln=ln+1
          i1=i1+1
          k1=1
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
         else if(l.EQ.5) then
          ln=ln+1
          if(ln.eq.1.OR.(ln.gt.1.AND.linen(ln-1,2).eq.j1)) then
            i1=i1+1
            k1=1
            linen(ln,1)=i1
            linen(ln,2)=j1
            linen(ln,3)=k1
           else
            j1=j1-1
            k1=1
            linen(ln,1)=i1
            linen(ln,2)=j1
            linen(ln,3)=k1
          end if
         else if(l.EQ.6) then
          ln=ln+1
          k1=0
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
          j1=j1-1
         else if(l.EQ.7) then
          ln=ln+1
          k1=1
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
          i1=i1-1
         else if(l.EQ.8) then
          ln=ln+1
          j1=j1+1
          k1=0
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
         else if(l.EQ.9) then
          ln=ln+1
          j1=j1+1
          k1=0
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
         else if(l.EQ.10) then
          ln=ln+1
          if(ln.eq.1.OR.(ln.gt.1.AND.linen(ln-1,1).gt.i1)) then
           j1=j1+1
           k1=0
           linen(ln,1)=i1
           linen(ln,2)=j1
           linen(ln,3)=k1
          else
           k1=0
           linen(ln,1)=i1
           linen(ln,2)=j1
           linen(ln,3)=k1
           j1=j1-1
          end if
         else if(l.EQ.11) then
          ln=ln+1
          j1=j1+1
          k1=0
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
         else if(l.EQ.12) then
          ln=ln+1
          i1=i1+1
          k1=1
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
         else if(l.EQ.13) then
          ln=ln+1
          i1=i1+1
          k1=1
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
         else if(l.EQ.14) then
          ln=ln+1
          k1=0
          linen(ln,1)=i1
          linen(ln,2)=j1
          linen(ln,3)=k1
          j1=j1-1
         else
          write(*,'(A12,5I5)') 'WARNING (-) ',i,j,i1,j1,l
         end if
! write(*,'(A3,7I4)') 'F: ',i,j,nline,lp,i1,j1,l
         if(ln.EQ.PNTS/2) then
           write(*,*) 'WARNING: ln larger than PNTS/2',PNTS/2
         end if
! **** check the labeling domain *****
         if (((linen(ln,3).EQ.0).AND. &
              (label(linen(ln,1)  ,linen(ln,2)) &
              *label(linen(ln,1)+1,linen(ln,2))).EQ.0) &
         .OR.((linen(ln,3).EQ.1).AND. &
              (label(linen(ln,1),linen(ln,2)) &
              *label(linen(ln,1),linen(ln,2)+1)).EQ.0)) then 
            ! write(*,'(A16,6I5)') 'on the boundary-',i,j,i1,j1,k1,ln
            ln=ln-1
            go to 101
         end if
        end do
!
 101  continue
      if(lp+ln.GT.0) then
         nline=nline+1
         if(nline.GT.LNS) then
            write(*,*) 'WARNING: number of contours larger than the maximum ',LNS
            return
         end if
         ll=0
         do l=1,ln
            ll=ll+1
            clines(nline,ll,:)=linen(ln-l+1,:)
         end do
         do l=1,lp
            ll=ll+1
            clines(nline,ll,:)=linep(l,:)
         end do
         line_points(nline)=ll
         line_label(nline)=label(clines(nline,1,1),clines(nline,1,2))
      end if
!
  end if
end do
end do
!
line_number=nline
!
i=0
allocate(line_mask(line_number))
line_mask(:)=.TRUE.
do i_label=1,maxval(line_label(1:line_number))
  n_same_label=0
  do i_line=1,line_number
     if(i_label.EQ.line_label(i_line)) then
        n_same_label=n_same_label+1
     end if
  end do
  do i_line=1,n_same_label
     ii_line = maxloc(line_points,line_label.EQ.i_label.AND.line_mask)
     line_mask(ii_line(1))=.FALSE.
     i=i+1
     line_points_out(i)=line_points(ii_line(1))
     line_label_out(i) =line_label(ii_line(1))
     clines_out(i,:,:)=clines(ii_line(1),:,:)
  end do
end do
!
if(i.NE.line_number) then
 write(*,*) 'WARNING (contour3)',i,line_number
end if
!
deallocate(line_mask)
deallocate(line_points,line_label)
deallocate(clines)
deallocate(idata)
deallocate(checked)
!
return
end subroutine find_pil
subroutine cal_twistflux(bottom,MX,MY,pilloc,r_rec,twistflux)
implicit none
integer,intent(in) :: MX,MY
integer,intent(in) :: pilloc(3)
real(8),dimension(0:MX,0:MY,10),intent(in) :: bottom
real(8),intent(in) :: r_rec
real(8),intent(out) :: twistflux
real(8) :: x0, y0, x, y, dx, dy, dxdy, r
real(8) :: sp,sn ! area
real(8) :: fp,fn ! magnetic flux
real(8) :: tfp,tfn ! magnetic twist flux
integer :: i, j, i0, i1, j0, j1
!
dx=bottom(1,0,1)-bottom(0,0,1)
dy=bottom(0,1,2)-bottom(0,0,2)
dxdy=dx*dy
!
x0 =bottom(pilloc(1),pilloc(2),1)
y0 =bottom(pilloc(1),pilloc(2),2)
if (pilloc(3).EQ.0) then
   x0=x0+dx/2
  else
   y0=y0+dy/2
end if
!
i0 = max( 0,pilloc(1)-int(r_rec/dx)-1)
i1 = min(MX,pilloc(1)+int(r_rec/dx)+1)
j0 = max( 0,pilloc(2)-int(r_rec/dy)-1)
j1 = min(MY,pilloc(2)+int(r_rec/dy)+1)
sp=0.0
sn=0.0
fp=0.0
fn=0.0
tfp=0.0
tfn=0.0
!
do i = i0, i1
    x=bottom(i,0,1)
do j = j0, j1
    y=bottom(i,j,2)
    r=sqrt((x-x0)**2+(y-y0)**2)
 if(r.LT.r_rec) then
   if(bottom(i,j,9).GT.0.0) then
      sp = sp+dxdy
      fp = fp+bottom(i,j,9)*dxdy
      tfp=tfp+bottom(i,j,9)*bottom(i,j,10)*dxdy
    else
      sn=sn+dxdy
      fn = fn+abs(bottom(i,j,9))*dxdy
      tfn=tfn+abs(bottom(i,j,9))*bottom(i,j,10)*dxdy
   end if
 end if
end do
end do
!
if(fp.eq.0.0.AND.fn.EQ.0.0) then
  twistflux=0.0
else if(fp.eq.0.0) then 
  twistflux=tfn
else if(fn.eq.0.0) then 
  twistflux=tfp
else
  twistflux=abs(tfp/fp+tfn/fn)*min(fp,fn)
end if
!
return
end subroutine cal_twistflux
subroutine cal_overlying(bottom,MX,MY,pilloc,r_rec,overlyingflux)
implicit none
integer,intent(in) :: MX,MY
integer,intent(in) :: pilloc(3)
real(8),dimension(0:MX,0:MY,10),intent(in) :: bottom
real(8),intent(in) :: r_rec
real(8),intent(out) :: overlyingflux
real(8) :: x0, y0, x, y, dx, dy, dxdy, r
real(8) :: distance_from_pil, farest_distance(2) 
real(8) :: xp_far, yp_far, xn_far, yn_far ! (x,y) at the farest point connecting to the PIL region
integer :: i, j
integer :: i0, i1, j0, j1 ! index for reconnection region
logical :: cross
!
dx=bottom(1,0,1)-bottom(0,0,1)
dy=bottom(0,1,2)-bottom(0,0,2)
dxdy=dx*dy
!
x0 =bottom(pilloc(1),pilloc(2),1)
y0 =bottom(pilloc(1),pilloc(2),2)
if (pilloc(3).EQ.0) then
   x0=x0+dx/2
  else
   y0=y0+dy/2
end if
!
i0 = max( 0,pilloc(1)-int(r_rec/dx)-1)
i1 = min(MX,pilloc(1)+int(r_rec/dx)+1)
j0 = max( 0,pilloc(2)-int(r_rec/dy)-1)
j1 = min(MY,pilloc(2)+int(r_rec/dy)+1)
!
farest_distance(:)=0.0
do i = i0, i1
    x=bottom(i,0,1)
do j = j0, j1
    y=bottom(0,j,2)
    r=sqrt((x-x0)**2+(y-y0)**2)
 if(r.LT.r_rec) then
     distance_from_pil = sqrt((bottom(i,j,4)-x0)**2 &
                             +(bottom(i,j,5)-y0)**2)
   if(bottom(i,j,9).GT.0.0) then
     if(distance_from_pil.gt.farest_distance(1)) then
        farest_distance(1)=distance_from_pil
        xp_far = bottom(i,j,4)
        yp_far = bottom(i,j,5)
     end if
   else
     if(distance_from_pil.gt.farest_distance(2)) then
        farest_distance(2)=distance_from_pil
        xn_far = bottom(i,j,4)
        yn_far = bottom(i,j,5)
     end if
   end if
 end if
end do
end do
!
if(farest_distance(1).eq.0.0.AND.farest_distance(2).eq.0.0) then
   overlyingflux=0.0
   write(*,*) 'WARNING (subroutine cal_overlying): farest_distance(1) =',farest_distance(1),r_rec
   write(*,*) 'WARNING (subroutine cal_overlying): farest_distance(2) =',farest_distance(2),r_rec
   return
end if
!
overlyingflux=0.0
do i = 0, MX
do j = 0, MY
  if(bottom(i,j,9).gt.0.0) then
     call crossing_1(xn_far,yn_far,xp_far,yp_far, &
          bottom(i,j,1),bottom(i,j,2),bottom(i,j,4),bottom(i,j,5),cross)
     if(cross) then
        overlyingflux=overlyingflux+bottom(i,j,9)
     end if
  end if
end do 
end do
overlyingflux = overlyingflux*dxdy
return
end subroutine cal_overlying
subroutine cal_overlying2(bottom0,bottom,label,MX,MY, &
                          pilloc,pil_label,r_rec,     &
                          o_flux,o_area,o_fenergy,fenergy_label)
implicit none
integer,intent(in) :: MX,MY
integer,intent(in),dimension(0:MX,0:MY) :: label
integer,intent(in) :: pilloc(3),pil_label
real(8),dimension(0:MX,0:MY,10),intent(in) :: bottom0,bottom
real(8),intent(in) :: r_rec,fenergy_label
real(8),intent(out) :: o_flux,o_area,o_fenergy
real(8),parameter :: PI=3.14159265358979323846D0
real(8),parameter :: PI4=PI*4
real(8),parameter :: PI8=PI*8
real(8),parameter :: Mm2cm=1.0D8
real(8) :: x0, y0, x, y, dx, dy, r
real(8) :: dxdy_cgs,del_bh
real(8) :: distance_from_pil, farest_distance(2) 
real(8) :: xp_far, yp_far, xn_far, yn_far 
! (x,y) at the farest point connecting to the PIL region
integer :: i, j
integer :: i0, i1, j0, j1 ! index for reconnection region
logical :: cross
!
dx=bottom(1,0,1)-bottom(0,0,1)
dy=bottom(0,1,2)-bottom(0,0,2)
dxdy_cgs=dx*dy*Mm2cm**2
!
x0 =bottom(pilloc(1),pilloc(2),1)
y0 =bottom(pilloc(1),pilloc(2),2)
if (pilloc(3).EQ.0) then
   x0=x0+dx/2
  else
   y0=y0+dy/2
end if
!
i0 = max( 0,pilloc(1)-int(r_rec/dx)-1)
i1 = min(MX,pilloc(1)+int(r_rec/dx)+1)
j0 = max( 0,pilloc(2)-int(r_rec/dy)-1)
j1 = min(MY,pilloc(2)+int(r_rec/dy)+1)
!
farest_distance(:)=0.0
do i = i0, i1
    x=bottom(i,0,1)
do j = j0, j1
    y=bottom(0,j,2)
    r=sqrt((x-x0)**2+(y-y0)**2)
 if(r.LT.r_rec) then
     distance_from_pil = sqrt((bottom(i,j,4)-x0)**2 &
                             +(bottom(i,j,5)-y0)**2)
   if(bottom(i,j,9).GT.0.0) then
     if(distance_from_pil.gt.farest_distance(1)) then
        farest_distance(1)=distance_from_pil
        xp_far = bottom(i,j,4)
        yp_far = bottom(i,j,5)
     end if
   else
     if(distance_from_pil.gt.farest_distance(2)) then
        farest_distance(2)=distance_from_pil
        xn_far = bottom(i,j,4)
        yn_far = bottom(i,j,5)
     end if
   end if
 end if
end do
end do
!
if(farest_distance(1).eq.0.0.AND.farest_distance(2).eq.0.0) then
   o_flux=0.0
   write(*,*) 'WARNING (subroutine cal_overlying2): farest_distance(1) =',farest_distance(1),r_rec
   write(*,*) 'WARNING (subroutine cal_overlying2): farest_distance(2) =',farest_distance(2),r_rec
   return
end if
!
o_flux=0.0
o_area=0.0
o_fenergy=0.0
do i = 0, MX
do j = 0, MY
  if(label(i,j).eq.pil_label) then
!
     call crossing_1(x0,y0,xp_far,yp_far, &
          bottom(i,j,1),bottom(i,j,2),bottom(i,j,4),bottom(i,j,5),cross)
   if(cross) then
        o_flux=o_flux+abs(bottom(i,j,9))
        del_bh=sqrt((bottom(i,j,7)-bottom0(i,j,7))**2 &
                   +(bottom(i,j,8)-bottom0(i,j,8))**2)
   ! if(del_bh.gt.ferner_label) then
        o_area=o_area+1.0d0
        o_fenergy=o_fenergy+del_bh**2
!
   else
!
     call crossing_1(x0,y0,xn_far,yn_far, &
          bottom(i,j,1),bottom(i,j,2),bottom(i,j,4),bottom(i,j,5),cross)
     if(cross) then
        o_flux=o_flux+abs(bottom(i,j,9))
        del_bh=sqrt((bottom(i,j,7)-bottom0(i,j,7))**2 &
                   +(bottom(i,j,8)-bottom0(i,j,8))**2)
   ! if(del_bh.gt.fenergy_label) then
        o_area=o_area+1.0d0
        o_fenergy=o_fenergy+del_bh**2
     end if
   end if
  end if
end do 
end do
o_flux = o_flux*dxdy_cgs/2
o_area = o_area*dxdy_cgs
o_fenergy = o_fenergy*dxdy_cgs*sqrt(o_area)/PI8
return
end subroutine cal_overlying2
subroutine plot_circle(x0,y0,r)
implicit none
integer, parameter :: DP = kind(1.0d0)
integer, parameter :: SP = kind(1.0)
real(DP), parameter :: PI=3.14159265358979323846D0
real(DP), parameter :: PI2=PI*2
real(DP) :: dphi
integer,parameter :: NC=20
integer :: i
real(DP),intent(in) :: x0,y0,r
real(SP) :: cx(0:NC),cy(0:NC)
!
dphi=PI2/NC
do i = 0, NC
 cx(i) = x0+r*cos(dphi*i)
 cy(i) = y0+r*sin(dphi*i)
end do
!
call pgline(NC+1,cx,cy)
!
return
end subroutine plot_circle
